#! /bin/bash

if [ "$2" == "" ]; then
    echo " usage: results.sh <times> <file>"
    exit 1
fi

each=$1
FILE=$2

function times {

     #echo "scale=2; (($1-$2)*100)/$1" | bc
    echo -n `echo "scale=2; ($1/$2)" | bc`
    echo "x"
}

function perc {

    echo "scale=2; (($1-$2)*100)/$1" | bc
}

typs=( "        Hand" "     Visitor" "    * Inline" "* InlineHeap" "      Static" "  Reflective" );

for j in 0 1 2 3; do # 4 5; do
        echo -n " {\\sc  ${typs[$j]}} "
        for i in MaxEnv Simplify Compile; do
            res=`./average.sh $each "java $i $FILE $j"`
            echo -n " $res "
        done
        echo "; \\\\\\hline"
done

echo
